#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <conio.h>
#include <ctype.h>
#include <windows.h>

__declspec(dllexport)
int WINAPI VeryPDF_PDF2Vector(LPCTSTR lpCommand);
__declspec(dllexport)
int WINAPI VeryPDF_PDF2VectorFromMemory(LPBYTE lpPDFData, int nDataLen, LPCTSTR lpstrOutFile, LPCTSTR lpCommand);

int ConvertPDFToOtherFormatsFromMemory(char *lpInFile, char *lpOutFile)
{
	LPBYTE lpData = NULL;
	int nLength = 0;
	FILE *file = fopen(lpInFile,"rb");
	if(!file)
		return -1001;
	nLength = _filelength(fileno(file));
	if(nLength <= 0)
	{
		fclose(file);
		return -1002;
	}
	lpData = new BYTE[nLength];
	if(lpData == NULL)
		return -1003;
	fread(lpData,1,nLength,file);
	fclose(file);
	int nRet = VeryPDF_PDF2VectorFromMemory(lpData, nLength, lpOutFile, "pdf2vec -swfburst2");
	delete []lpData;

	return nRet;
}
void main(int argc, char **argv)
{
	if(argc < 3)
	{
		printf("%s C:\\in.pdf C:\\out.emf\n", argv[0]);
		printf("%s C:\\in.pdf C:\\out.wmf\n", argv[0]);
		printf("%s C:\\in.pdf C:\\out.pcl\n", argv[0]);
		printf("%s C:\\in.pdf C:\\out.swf\n", argv[0]);
		printf("%s C:\\in.pdf C:\\out.ps\n", argv[0]);
		printf("%s C:\\in.pdf C:\\out.eps\n", argv[0]);
		return;
	}
	int nRet = 0;
	if(1)
	{
		char *lpLicenseKey = "XXXXXXXXXXXXXXX";
		char szCommandLine[1024];
		sprintf(szCommandLine,"pdf2vec -$ \"%s\" ",lpLicenseKey);
		for(int i = 1; i < argc; i++)
		{
			strcat(szCommandLine, " \"");
			strcat(szCommandLine, argv[i]);
			strcat(szCommandLine, "\"");
		}
		nRet = VeryPDF_PDF2Vector(szCommandLine);
		printf("VeryPDF_PDF2Vector, Return value: %d\n", nRet);
	}

	if(0)
	{
		char *lpInFile = argv[argc-2];
		char *lpOutFile = argv[argc-1];
		
		char path_buffer[_MAX_PATH];
		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		char fname[_MAX_PATH];
		char ext[_MAX_EXT];
		_splitpath( lpOutFile, drive, dir, fname, ext);
		strcat(fname, "-PDF2VectorFromMemory");
		_makepath( path_buffer, drive, dir, fname, ext );
		lpOutFile = path_buffer;
		
		nRet = ConvertPDFToOtherFormatsFromMemory(lpInFile, lpOutFile);
		printf("VeryPDF_PDF2VectorFromMemory, Return value: %d\n", nRet);
	}
}
